*This is part of a series of Leetcode solution explanations (index). If you liked this solution or found it useful,* *please like**this post and/or* *upvote**my solution post on Leetcode's forums.*

####
Leetcode Problem #1423 (*Medium*): Maximum Points You Can Obtain from Cards

####
*Description:*

*Description:*

(*Jump to*: *Solution Idea* || *Code*: *JavaScript* | *Python* | *Java* | *C++*)

There are several cards

arranged in a row, and each card has an associated number of points The points are given in the integer array`cardPoints`

.In one step, you can take one card from the beginning or from the end of the row. You have to take exactly

`k`

cards.Your score is the sum of the points of the cards you have taken.

Given the integer array

`cardPoints`

and the integer`k`

, return themaximum scoreyou can obtain.

####
*Examples:*

*Examples:*

Example 1: Input: cardPoints = [1,2,3,4,5,6,1], k = 3 Output: 12 Explanation: After the first step, your score will always be 1. However, choosing the rightmost card first will maximize your total score. The optimal strategy is to take the three cards on the right, giving a final score of 1 + 6 + 5 = 12.

Example 2: Input: cardPoints = [2,2,2], k = 2 Output: 4 Explanation: Regardless of which two cards you take, your score will always be 4.

Example 3: Input: cardPoints = [9,7,7,9,7,7,9], k = 7 Output: 55 Explanation: You have to take all the cards. Your score is the sum of points of all cards.

Example 4: Input: cardPoints = [1,1000,1], k = 1 Output: 1 Explanation: You cannot take the card in the middle. Your best score is 1.

Example 5: Input: cardPoints = [1,79,80,1,1,1,200,1], k = 3 Output: 202

####
*Constraints:*

*Constraints:*

`1 <= cardPoints.length <= 10^5`

`1 <= cardPoints[i] <= 10^4`

`1 <= k <= cardPoints.length`

####
*Idea:*

*Idea:*

(*Jump to*: *Problem Description* || *Code*: *JavaScript* | *Python* | *Java* | *C++*)

Since we're forced to take **K** amount of cards no matter what, we can solve this problem with a **two-pointer system** with a **sliding window** approach. Instead of counting the sum of the values *between* the two pointers, we'll instead be counting the sum of the values *outside* the sliding window.

We can start by iterating through the first **K** cards of our card list (**C**) and finding the **total** points. At this point, our reverse window will be the cards from **i = K** to **j = C.length - 1**. At each iteration, we'll slide the window backwards, removing one card from the left side (**-C[i]**) and adding one card from the right side (**+C[j]**) each time.

We should keep track of the **best** possible result at each iteration, then **return best** once we reach the end.

**Time Complexity: O(K)****Space Complexity: O(1)**

####
*Javascript Code:*

*Javascript Code:*

(*Jump to*: *Problem Description* || *Solution Idea*)

```
var maxScore = function(C, K) {
let total = 0
for (let i = 0; i < K; i++) total += C[i]
let best = total
for (let i = K - 1, j = C.length - 1; ~i; i--, j--)
total += C[j] - C[i], best = Math.max(best, total)
return best
};
```

####
*Python Code:*

*Python Code:*

(*Jump to*: *Problem Description* || *Solution Idea*)

```
class Solution:
def maxScore(self, C: List[int], K: int) -> int:
best = total = sum(C[:K])
for i in range (K-1, -1, -1):
total += C[i + len(C) - K] - C[i]
best = max(best, total)
return best
```

####
*Java Code:*

*Java Code:*

(*Jump to*: *Problem Description* || *Solution Idea*)

```
class Solution {
public int maxScore(int[] C, int K) {
int total = 0;
for (int i = 0; i < K; i++) total += C[i];
int best = total;
for (int i = K - 1, j = C.length - 1; i >= 0; i--, j--) {
total += C[j] - C[i];
best = Math.max(best, total);
}
return best;
}
}
```

####
*C++ Code:*

*C++ Code:*

(*Jump to*: *Problem Description* || *Solution Idea*)

```
class Solution {
public:
int maxScore(vector<int>& C, int K) {
int total = 0;
for (int i = 0; i < K; i++) total += C[i];
int best = total;
for (int i = K - 1, j = C.size() - 1; ~i; i--, j--)
total += C[j] - C[i], best = max(best, total);
return best;
}
};
```

## Top comments (1)

Sharing my Java Solution

## Rohithv07 / LeetCodeTopInterviewQuestions

## Leetcode Top Interview questions discussed in Leetcode. https://leetcode.com/explore/interview/card/top-interview-questions

## LeetCodeTopInterviewQuestions

Leetcode Top Interview questions discussed in Leetcode. leetcode.com/explore/interview/car...

Also Question answered from CodeSignal.com : app.codesignal.com/